import { vitest } from 'vitest';
import { type RouteLocation } from 'vue-router';

import { type MountingOptions, shallowMount } from '@vue/test-utils';
import sinon, { type SinonStubbedInstance } from 'sinon';

import AlertService from '@/shared/alert/alert.service';

import UtenteAppDetails from './utente-app-details.vue';
import UtenteAppService from './utente-app.service';

type UtenteAppDetailsComponentType = InstanceType<typeof UtenteAppDetails>;

let route: Partial<RouteLocation>;
const routerGoMock = vitest.fn();

vitest.mock('vue-router', () => ({
  useRoute: () => route,
  useRouter: () => ({ go: routerGoMock }),
}));

const utenteAppSample = { id: 123 };

describe('Component Tests', () => {
  let alertService: AlertService;

  afterEach(() => {
    vitest.resetAllMocks();
  });

  describe('UtenteApp Management Detail Component', () => {
    let utenteAppServiceStub: SinonStubbedInstance<UtenteAppService>;
    let mountOptions: MountingOptions<UtenteAppDetailsComponentType>['global'];

    beforeEach(() => {
      route = {};
      utenteAppServiceStub = sinon.createStubInstance<UtenteAppService>(UtenteAppService);

      alertService = new AlertService({
        i18n: { t: vitest.fn() } as any,
        toast: {
          show: vitest.fn(),
        } as any,
      });

      mountOptions = {
        stubs: {
          'font-awesome-icon': true,
          'router-link': true,
        },
        provide: {
          alertService,
          utenteAppService: () => utenteAppServiceStub,
        },
      };
    });

    describe('Navigate to details', () => {
      it('Should call load all on init', async () => {
        // GIVEN
        utenteAppServiceStub.find.resolves(utenteAppSample);
        route = {
          params: {
            utenteAppId: `${123}`,
          },
        };
        const wrapper = shallowMount(UtenteAppDetails, { global: mountOptions });
        const comp = wrapper.vm;
        // WHEN
        await comp.$nextTick();

        // THEN
        expect(comp.utenteApp).toMatchObject(utenteAppSample);
      });
    });

    describe('Previous state', () => {
      it('Should go previous state', async () => {
        utenteAppServiceStub.find.resolves(utenteAppSample);
        const wrapper = shallowMount(UtenteAppDetails, { global: mountOptions });
        const comp = wrapper.vm;
        await comp.$nextTick();

        comp.previousState();
        await comp.$nextTick();

        expect(routerGoMock).toHaveBeenCalledWith(-1);
      });
    });
  });
});
